{-----------------------------------------------------------------------------}
{        General Declarations                                                 }
{-----------------------------------------------------------------------------}
Type TPString = String[255];


{Command array for the Vdp access }

Var _sx  :Integer Absolute $f562 ;
    _sy  :Integer Absolute $f564 ;
    _dx  :Integer Absolute $f566 ;
    _dy  :Integer Absolute $f568 ;
    _nx  :Integer Absolute $f56a ;
    _ny  :Integer Absolute $f56c ;
    _col :Byte Absolute    $f56e ;
    _arg :Byte Absolute    $f56f ;
    _cmd :Byte Absolute    $f570 ;

Var Jiffy: integer absolute $FC9E; 
    ClickSW: integer absolute $F3DB;

{Vdp Copy commands }

Const HMMC = $F0 ; {High speed Byte Cpu  -> Vram }
      YMMM = $E0 ; {High speed Byte Vram -> Vram in y-axis }
      HMMM = $D0 ; {High speed Byte Vram -> Vram in x- and y-axis }
      HMMV = $C0 ; {High speed Byte Vdp  -> Vram = paint a box }

      LMMC = $B0 ; {Logical Dot     Cpu  -> Vram }
      LMCM = $A0 ; {Logical Dot     Vram -> Cpu  }
      LMMM = $90 ; {Logical Dot     Vram -> Vram }
      LMMV = $80 ; {Logical Dot     Vdp  -> Vram = paint a box }


{Copy directions for the ARG-register }

      Copy_Right = 0;
      Copy_Down  = 0;
      Copy_Left  = 4;
      Copy_Up    = 8;
      ExpansionVram   = 32 ;
      Vram  = 0 ;

Const TPSET=8;

Procedure Screen(mode:Byte);
{ Igual ao screen do Basic }
Const EXPTBL = $fcc0;
      CALSLT = $001C;
      CHGMOD = $005F;

Begin
     Inline  (
              $f3                { di }
             /$3a/mode           { LD A,(MODE) }
             /$fd/$2a/$c0/$fc    { LD IY,(EXPTBL - 1 }
             /$DD/$21/$5f/00     { LD IX,CHGMOD }
             /$CD/$1c/00         { CALL CALSLT }
             /$fb                { EI }
             );

End;

Procedure Color(ForeGroundColor,BackGroudColor,BorderColor:Byte);
{ Igual ao color do Basic }

Var FORCLR :Byte Absolute $F3E9;
    BAKCLR :Byte Absolute $f3ea;
    BDRCLR :Byte Absolute $f3eb;

Begin
    FORCLR := ForeGroundColor;
    BAKCLR := BackGroudColor;
    BDRCLR := BorderColor;
    Inline (  $f3/
              $fd/$2a/$c0/$fc    { LD IY,(EXPTBL - 1 }
             /$DD/$21/$62/00     { LD IX,CHGCLR }
             /$CD/$1c/00/$fb     { CALL CALSLT }
           );
End;


Var
   VA:byte;
   VHL,VBC,VDE:integer;

Const
   GTSTCK=$D5;     {retorna o estado do joystick selecionado}
   GTTRIG=$D8;     {retorna o estado do botao de disparo selecionado}
   WRTPSG=$93;     {grava um byte num registro do PSG}

Procedure CallRom(VIX:integer);
BEGIN
inline($F3/$CD/*+19/$FB/$32/VA/$22/VHL/$ED/$43/VBC/$ED/$53/VDE/$18/$1B/
       $DD/$2A/VIX/$3A/VA/$2A/VHL/$ED/$4B/VBC/$ED/$5B/VDE/$08/$DB/$A8/
       $F5/$E6/$F0/$C3/$8C/$F3/$FB);
END;

Function Stick(n:byte):byte;
BEGIN
  VA:=n;
  CallRom(GTSTCK);
  Stick:=VA;
END;

Function Strig(n:byte):boolean;
BEGIN
   VA:=n;
   CallRom(GTTRIG);
   Strig:=(va<>0);
END;

Procedure Sound(r,v:byte);
BEGIN
   VA:=r;
   VDE:=v;
   CallRom(WRTPSG);
END;

Type StringType = String[80];

procedure CLS;
begin
  Inline  (
           $f3                 { di }
           /$fd/$2a/$c0/$fc    { LD IY,(EXPTBL - 1 }
           /$DD/$21/$c3/00     { LD IX,CHGMOD }
           /$CD/$1c/00         { CALL CALSLT }
           /$fb                { EI }
           );
  
end;

procedure cls2;

begin
  inline ($f3/$af/          { xor a         }
          $fd/$2a/$c0/$fc/  { ld iy,(#fcc0) }
          $dd/$21/$c3/$00/  { ld ix,#c3     }
          $cd/$1c/$00/$fb); { call #1c      }
end;

function Inkey:char;
var bt:byte;
begin
     Inkey:=chr(0);
     Mem[$FCA9]:=1;
     Inline($f3/$fd/$2a/$c0/$fc/$DD/$21/$9F/00     
            /$CD/$1c/00/$32/bt/$fb);
     Inkey:=chr(bt);
     Mem[$FCA9]:=0;
end;

