type

  colortype = (transparant, black, medium_green, light_green,
               dark_blue, light_blue, dark_red, cyan,
               medium_red, light_red, dark_yellow, light_yellow,
               dark_green, magenta, gray, white ) ;


TYPE LITERAL= STRING [80];
     AREA_BUFFER = ARRAY [1..1024] OF BYTE;
     STR8 = STRING[8];
     STR12 = STRING[12];



VAR DADOS1,DADOS2,DADOSX :LITERAL; 
    spr:string[8];
    XA,XB,YA,YB,CS,RS :STRING [3];
    ScreenData: array[0..16390] of byte;

procedure Setcolor (scolor: byte) ;
begin
    mem[$f3f2]:=scolor;
end ;

procedure Swap_Int (var i,j : integer) ;
var temp : integer ;
begin
    temp := i ;
    i := j ;
    j := temp ;
end ;

PROCEDURE WRITEMEM(ENDERECO:INTEGER;TEXTO:LITERAL);
VAR INDICE:INTEGER;
BEGIN
    FOR INDICE:=1 TO  LENGTH (TEXTO) DO BEGIN
        MEM [ENDERECO]:= ORD(TEXTO[INDICE]);
        ENDERECO:= ENDERECO+1;
    END;
    MEM [ENDERECO]:= 0 
END;


PROCEDURE PROGRAME (DADOSX:LITERAL);
VAR SLOT: INTEGER;
BEGIN
IF PORT[168] = $FF THEN SLOT:=$F0
   ELSE SLOT:= $A0;

  DADOS1:= #$DB+#$A8+#$F5+#$3E+CHR(SLOT)+#$D3+#$A8;
  DADOS2:= #$F1+#$D3+#$A8+#$C9;
  DADOSX:= DADOS1+DADOSX+DADOS2;
  WRITEMEM ($B100,DADOSX);
  INLINE ($F3/$C3/$00/$B1/$FB);
END;
                    
PROCEDURE SPRITE(N:INTEGER;TABELA:STR8);
BEGIN             
  WRITEMEM($B000,TABELA);
  DADOSX:=#$3E+CHR(N)+#$CD+#$84+#00+#$EB+#$21+#00+#$B0+#01+#08+#00+#$CD+#$5C+#00;
  PROGRAME(DADOSX);
END;
                    

Procedure Draw_Horizontal_Line (x, y, dx : integer) ;
begin
    inline (
              $ED/$5B/y/                  {       LD   DE,(y)    }
              $ED/$4B/x/                  {       LD   BC,(x)    }
              $FD/$2A/$C0/$FC/            {       LD   IY,(EXPT) }
              $DD/$21/$11/$01/            {       LD   IX,MAPXYC }
              $CD/$1C/$00/                {       CALL CALSLT    }
              $2A/dx/                     {       LD   HL,(dx)   }
              $FD/$2A/$C0/$FC/            {       LD   IY,(EXPT) }
              $DD/$21/$23/$01/            {       LD   IX,NSETCX }
              $CD/$1C/$00                 {       CALL CALSLT    }
           ) ;
end ;

procedure Draw_Vertical_Line (x, y, dy : integer) ;
begin

    inline (
              $ED/$5B/y/                  {       LD   DE,(y)    }
              $13/                        {       INC  DE        }
              $ED/$4B/x/                  {       LD   BC,(x)    }
              $FD/$2A/$C0/$FC/            {       LD   IY,(EXPT) }
              $DD/$21/$11/$01/            {       LD   IX,MAPXYC }
              $CD/$1C/$00/                {       CALL CALSLT    }
              $11/$01/$00/                {       LD   DE, 1     }
              $D5/                        { vloop PUSH DE        }
              $FD/$2A/$C0/$FC/            {       LD   IY,(EXPT) }
              $DD/$21/$20/$01/            {       LD   IX,SETC   }
              $CD/$1C/$00/                {       CALL CALSLT    }
              $FD/$2A/$C0/$FC/            {       LD   IY,(EXPT) }
              $DD/$21/$08/$01/            {       LD   IX,DOWNC  }
              $CD/$1C/$00/                {       CALL CALSLT    }
              $D1/                        {       POP  DE        }
              $13/                        {       INC  DE        }
              $2A/dy/                     {       LD   HL,(dy)   }
              $7C/                        {       LD   A,L       }
              $92/                        {       SUB  E         }
              $C2/*-31/                   {       JP   NZ,vloop  }
              $7D/                        {       LD   A,H       }
              $93/                        {       SUB  D         }
              $C2/*-36                    {       JP   NZ,vloop  }
           ) ;

end ;

procedure Draw_Box(x1,y1,x2,y2: integer; bcolor: byte; bfill: boolean);
var dx, dy : integer ;

begin

  if not ((x1<x2) and (y1<y2)) then begin
     if (x2<x1) and (y2<y1) then begin
        swap_int(x1,x2) ;
        swap_int(y1,y2) ;
     end else begin
               halt ;
     end
  end ;

  dy:=y2-y1+1;
  dx:=x2-x1+1;

  SetColor(bcolor) ;

  if bfill then begin
     dy := dy + 1 ;
     inline (
             $ED/$5B/y1/                 {       LD   DE,(y1)   }
             $ED/$4B/x1/                 {       LD   BC,(x1)   }
             $FD/$2A/$C0/$FC/            {       LD   IY,(EXPT) }
             $DD/$21/$11/$01/            {       LD   IX,MAPXYC }
             $CD/$1C/$00/                {       CALL CALSLT    }
             $11/$01/$00/                {       LD   DE, 1     }
             $D5/                        { yloop PUSH DE        }
             $2A/dx/                     {       LD   HL,(dx)   }
             $FD/$2A/$C0/$FC/            {       LD   IY,(EXPT) }
             $DD/$21/$23/$01/            {       LD   IX,NSETCX }
             $CD/$1C/$00/                {       CALL CALSLT    }
             $FD/$2A/$C0/$FC/            {       LD   IY,(EXPT) }
             $DD/$21/$08/$01/            {       LD   IX,DOWNC  }
             $CD/$1C/$00/                {       CALL CALSLT    }
             $D1/                        {       POP  DE        }
             $13/                        {       INC  DE        }
             $2A/dy/                     {       LD   HL,(dy)   }
             $7C/                        {       LD   A,L       }
             $92/                        {       SUB  E         }
             $C2/*-34/                   {       JP   NZ,yloop  }
             $7D/                        {       LD   A,H       }
             $93/                        {       SUB  D         }
             $C2/*-39                    {       JP   NZ,yloop  }
            ) ;
  end else begin
      Draw_Horizontal_line(x1,y1,dx) ;
      Draw_Horizontal_line(x1,y2,dx) ;
      Draw_Vertical_line(x1,y1,dy) ;
      Draw_Vertical_line(x2,y1,dy) ;

  end ;
end ; 
 
procedure writeblock_vram(nr_bytes, address, vram_address : integer  ) ;
{ writes block of data from ram adress to location vram_address in vram }
begin
    inline (  $F3/
              $FD/$2A/$C0/$FC/         {       LD   IY,(EXPT)   }
              $DD/$21/$5C/$00/         {       LD   IX,LDIRVM   }
              $ED/$4B/nr_bytes/        {       LD   BC,(nr_bytes}
              $2A/address/             {       LD   HL,(address)}
              $ED/$5B/vram_address/    {       LD   DE,(vram-ad)}
              $CD/$1C/$00/             {       CALL CALSLT      }
              $FB) ;

end ; { writeblock_vram }

Procedure Vpoke(Addr:integer; Value:byte);

Const CalSlt = $001c;
      WrtVrm = $004d;
      ExpTbl = $fcc1;

Begin
    Inline(
           $f3/              {Di}
           $2a/Addr/         {ld hl,(addr)}
           $3a/Value/        {ld a,(value)}
           { $fd/$21/$c0/$fc/  {ld iy,(exptbl-1)}
           $fd/$2a/$c0/$fc/  {ld iy,(exptbl-1)}
           $dd/$21/$4d/00/   {ld ix,wrtvrm}
           $cd/$1c/00/$FB    {call calslt}
           );
End; 
 
Procedure PSprite(Number, X,Y, Pattern,Color:byte);
Var Sprite : integer;
    Buf    :Array[0..3] Of Byte;
begin                   
   Sprite:=$1B00 + (Number*4);
   
   Buf[0] :=Y-1;
   Buf[1] :=X;
   Buf[2] :=Pattern;
   Buf[3] :=Color;
   writeblock_vram(4, addr(buf), Sprite);
end;

PROCEDURE LINE(X1,Y1,X2,Y2,C:INTEGER);
VAR DADOS:LITERAL;
BEGIN
 STR(X1,XA);
 STR(Y1,YA);
 STR(X2,XB);
 STR(Y2,YB);
 STR(C,CS);
 DADOS:='('+XA+','+YA+')'+CHR($F2)+'('+XB+','+YB+'),'+CS;
 WRITEMEM($B000,DADOS);
 DADOSX:=#$21+#00+#$B0+#$CD+#$0E+#$4B;
 PROGRAME(DADOSX);
END;

PROCEDURE LINEBF(X1,Y1,X2,Y2,C:INTEGER);
VAR DADOS:LITERAL;
BEGIN
 STR(X1,XA);
 STR(Y1,YA);
 STR(X2,XB);
 STR(Y2,YB);
 STR(C,CS);
 DADOS:='('+XA+','+YA+')'+CHR($F2)+'('+XB+','+YB+'),'+CS+',BF';
 WRITEMEM($B000,DADOS);
 DADOSX:=#$21+#00+#$B0+#$CD+#$0E+#$4B;
 PROGRAME(DADOSX);
END;
            
Procedure MSX1Pset(x,y,c:integer);
var Dados:Literal;

Begin
 STR(X,XA);
 STR(Y,YA);
 STR(C,CS);
 DADOS:='('+XA+','+YA+'),'+CS;
 WRITEMEM($B000,DADOS);
 DADOSX:=#$21+#00+#$B0+#$CD+#$EA+#$57;
 PROGRAME(DADOSX);
END;
            
Procedure Texto(Lin,Col:Integer; Texto:Literal);
Var C:Byte absolute $F3EA;
Indice,Ccomprimento: Integer;
Letra: Char;

Begin
  Ccomprimento:=Length(Texto);
    For indice:=1 to Ccomprimento do begin
        LETRA:=TEXTO[INDICE];
        msx1Pset(Col*6,(Lin*8),0);
        DADOSX:=#$3E+LETRA+#$CD+#$8D+#00;
        PROGRAME(DADOSX);
        Col:=Succ(Col);
        if Col>40 then begin
            Col:=0;
            Lin:=Succ(LIN);
        end;
    end;
end;

Procedure CenterText(Lin:integer; stexto:literal);
var pos:integer;
begin           

  pos:=256-(length(stexto)*8);
  pos:=pos div 2;     
  pos:=pos div 4;
  Texto(lin,pos,stexto);
end;

Procedure LoadScreen(fname: Stringtype; show: boolean);
begin
 FcbPointer:=MSXOpen(fname);  
 MSXRead(FcbPointer, 16391, 1, Addr(ScreenData));
 MSXClose(FcbPointer);           
 
 if show then writeblock_vram(16384, Addr(ScreenData)+7, 0);
end;

Procedure ViewScreen;
begin
 writeblock_vram(16384,Addr(ScreenData)+7, 0);
end;

Procedure Sprite8x8;
begin

DADOSX:=#$3A+#$E0+#$F3+#$CB+#$88+#$47+
        #$0E+#$01+#$CD+#$47+#$00+#$FB;
PROGRAME(DADOSX);

end;

Procedure Sprite16x16;
begin

DADOSX:=#$3A+#$E0+#$F3+#$CB+#$CF+#$47+
        #$0E+#$01+#$CD+#$47+#$00+#$FB;
PROGRAME(DADOSX);

end;

PROCEDURE SPRITE_AMPLIADO;
BEGIN
  DADOSX:=#$3A+#$E0+#$F3+#$CB+#$C7+#$47+
          #$0E+#01+#$CD+#$47+#00;
  PROGRAME(DADOSX);
END;
